##########################################################################
#                                                                        #
#           copyright (c) 2005 ITB, Humboldt-University Berlin           #
#           written by: Raphael Ritz, r.ritz@biologie.hu-berlin.de       #
#                                                                        #
##########################################################################

from AccessControl import getSecurityManager

def setEditorRole(state_change):
    object = state_change['object']
    userid = getSecurityManager().getUser().getId()
    object.manage_addLocalRoles(userid, ['Editor'])

def unsetEditorRole(state_change):
    object = state_change['object']
    userids = object.users_with_local_role('Editor')
    for id in userids:
        roles_to_keep = [r for r in object.get_local_roles_for_userid(id) \
                         if r != 'Editor']
        object.manage_delLocalRoles([id])
	if roles_to_keep:
            object.manage_addLocalRoles(id, roles_to_keep)

