## Controller Python Script  "lock_and_edit"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=
##title=
##
wft = context.portal_workflow
locking_state = wft.getInfoFor(context,
                               'locking_state',
                               None,
                               'locking_workflow')
if locking_state is None:
    # no action to be taken
    return state.set(status='success')

if locking_state == 'unlocked':
    wft.doActionFor(context,'lock')
    return state.set(status='success',
           	     portal_status_message='Item locked.')

if 'locking_state' == 'locked':
    # are we the current editor?
    user = context.portal_membership.getAuthenticatedMember()
    if user.has_role('Editor', context):
        return state.set(status='success')
    else:
        return state.set(status='failure',
                         portal_status_message='This item is locked.')
 